| Test Number | Description                                                                                                                                                                                                                                                                                      | HTML validation | Plain validation | HTML text validation |
| ----------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | --------------- | ---------------- | -------------------- |
| 01          | Empty body                                                                                                                                                                                                                                                                                       | ok              | ok               | ok                   |
| 02          | Simple text                                                                                                                                                                                                                                                                                      | ok              | ok               | ok                   |
| 03          | Embedded image                                                                                                                                                                                                                                                                                   | fail            | ok               | fail                 |
| 04          | Embedded image with text                                                                                                                                                                                                                                                                         | fail            | ok               | fail                 |
| 05          | Complex text on multiple lines with some text bold, italic, lists, no attachments                                                                                                                                                                                                                | fail            | ok               | fail                 |
| 06          | Multiple MIME attachments and text                                                                                                                                                                                                                                                               | ok              | ok               | ok                   |
| 07          | Multiple Drive attachments and text                                                                                                                                                                                                                                                              | ok              | ok               | ok                   |
| 08          | Complex email with formatted text, embedded images, MIME and GDrive attachments                                                                                                                                                                                                                  | fail            | ok               | fail                 |
| 09          | 2 replies with test case 01                                                                                                                                                                                                                                                                      | fail            | ok               | fail                 |
| 10          | 2 replies with test case 02                                                                                                                                                                                                                                                                      | -               | -                | -                    |
| 11          | 2 replies with test case 03                                                                                                                                                                                                                                                                      | -               | -                | -                    |
| 12          | 2 replies with test case 04                                                                                                                                                                                                                                                                      | -               | -                | -                    |
| 13          | 2 replies with test case 05                                                                                                                                                                                                                                                                      | -               | -                | -                    |
| 14          | 2 replies with test case 06                                                                                                                                                                                                                                                                      | -               | -                | -                    |
| 15          | 2 replies with test case 07                                                                                                                                                                                                                                                                      | -               | -                | -                    |
| 16          | 2 replies with test case 08                                                                                                                                                                                                                                                                      | -               | -                | -                    |
| 17          | Multiple forwarded emails using cases 01-08:<br><br>E.g. <br>- User A sends "case 01" to User B<br>- User B forwards "case 02" to User A<br>- User A forwards "case 03" to User B<br>...<br>- User B forwards "case 08" to User A<br>- User A completes circle by forwarding "case 01" to User B | -               | -                | -                    |

## Failed cases

### 03 and 04

#### HTML and Pseudoplain:

Exchange server amending `src` attribute of the inline pictures by replacing `contend-id` with path of the image in local system.

Diff example:

```
<IMG alt="Graphical user interface, application
    - Description automatically generated" src="cid:image001.png@01D6D86C.278036F0"/>
    + Description automatically generated" src="file:////Users/igorwork/Library/Containers/com.microsoft.Outlook/Data/Library/Application%20Support/Microsoft/Temp/~WRS%7b8742DBE2-7D16-BB48-A6CC-0B0EA1F87047%7d.fld/image001.png"/>

```

### 05

#### HTML

Outlook Desktop amending HTML structure

Diff example:

```
  <TEXT>|'''Strong''italictext'':-)'''</TEXT>
  </P>
- <LI>
+ <P>
  <TEXT>Bulletpointed.|*Bulletpointed.</TEXT>
- </LI>
+ </P>
- <LI>
+ <P>
  <TEXT>Numberedlist.|<tab>0Numberedlist.</TEXT>
- </LI>
+ </P>
```

### 08

HTML matching failure caused by combination of 03, 04 and 05 failures

### 09

#### HTML

As a part of normalisation routine, we are getting rid of the QR codes.

This happens using HTML `id` attribute.

In normal case, a `div` with QR code looks like this:

```html
<div id="test-for-us">
  <p class="MsoNormal">
    <a
      href="https://emea01.safelinks.protection.outlook.com/?url=https%3A%2F%2Foffice.test.vereign.com%2F%3Fq%3DCiBYx1IuGYgYTzhqNVrddWtwYWAeWhAcwBM2LxTlmudAjxIgU6ynQR39MnKsiLu1DDoaH8W0veYwWpacAs6XT-1SIGE%3D%26timestamp%3D1608738280784&amp;data=04%7C01%7C%7C0b01e377f850417ce94608d8a759c2bc%7C84df9e7fe9f640afb435aaaaaaaaaaaa%7C1%7C0%7C637443351242842803%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=bmq5FE58MFOT13FV8yBqdK67jtlpPQx3MMOA0BsY4d4%3D&amp;reserved=0"
      target="_blank"
    >
      <!--... qr code image-->
    </a>
  </p>
</div>
```

in broken reply case, wrapping `div` with specified id is gone

```html
<p
  class="MsoNormal"
  style="mso-margin-top-alt: auto; mso-margin-bottom-alt: auto"
>
  &nbsp;
</p>
<p
  class="MsoNormal"
  style="mso-margin-top-alt: auto; mso-margin-bottom-alt: auto"
>
  <a
    href="https://emea01.safelinks.protection.outlook.com/?url=https%3A%2F%2Foffice.test.vereign.com%2F%3Fq%3DCiBYx1IuGYgYTzhqNVrddWtwYWAeWhAcwBM2LxTlmudAjxIgU6ynQR39MnKsiLu1DDoaH8W0veYwWpacAs6XT-1SIGE%3D%26timestamp%3D1608738280784&amp;data=04%7C01%7C%7Cb76d35214a2f4b89702b08d8a759f32b%7C84df9e7fe9f640afb435aaaaaaaaaaaa%7C1%7C0%7C637443352054987160%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=BSX%2BqcTJvzH1ttGrGEbpVUziAbY2M9n0%2Bj8fegO2aaE%3D&amp;reserved=0"
    originalsrc="https://office.test.vereign.com/?q=CiBYx1IuGYgYTzhqNVrddWtwYWAeWhAcwBM2LxTlmudAjxIgU6ynQR39MnKsiLu1DDoaH8W0veYwWpacAs6XT-1SIGE=&amp;timestamp=1608738280784"
    shash="N0i50hBF8Axb3v+1JS8ML+yvp6JqV6yBvv2V+PNNba7XLnfRCXJq1ih59HpquliNJIaEtNG03pY32DmzAfBB/G/1OSiTPP2sTqlMzSYJmYBYjIUvhayhC4OfSw14RDZMlET6QO2GsCPZ8Rrc+6n/ZOrwAkVw6ffyRtupiVnHLLg="
    target="_blank"
  >
    <!-- QR code image --> </a
  ><o:p></o:p>
</p>
```

### 10-17

Proceeding with rest cases will not have any effect unless problems stated above are fixed.
