| Test Number | Description                                                                                                                                                                                                                                                                                      | HTML validation | Plain validation | HTML text validation |
| ----------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | --------------- | ---------------- | -------------------- |
| 01          | Empty body                                                                                                                                                                                                                                                                                       | ok              | ok               | ok                   |
| 02          | Simple text                                                                                                                                                                                                                                                                                      | ok              | ok               | ok                   |
| 03          | Embedded image                                                                                                                                                                                                                                                                                   | ok              | ok               | ok                   |
| 04          | Embedded image with text                                                                                                                                                                                                                                                                         | ok              | ok               | ok                   |
| 05          | Complex text on multiple lines with some text bold, italic, lists, no attachments                                                                                                                                                                                                                | ok              | ok               | ok                   |
| 06          | Multiple MIME attachments and text                                                                                                                                                                                                                                                               | ok              | ok               | ok                   |
| 07          | Multiple OneDrive attachments and text                                                                                                                                                                                                                                                              | ok              | ok               | ok                   |
| 08          | Complex email with formatted text, embedded images, MIME and OneDrive attachments                                                                                                                                                                                                                  | ok              | ok               | ok                   |
| 09          | 2 replies with test case 01                                                                                                                                                                                                                                                                      | ok              | fail             | ok                   |
| 10          | 2 replies with test case 02                                                                                                                                                                                                                                                                      | ok              | fail             | ok                   |
| 11          | 2 replies with test case 03                                                                                                                                                                                                                                                                      | fail            | fail             | fail                 |
| 12          | 2 replies with test case 04                                                                                                                                                                                                                                                                      | fail            | fail             | fail                 |
| 13          | 2 replies with test case 05                                                                                                                                                                                                                                                                      | fail            | fail             | fail                 |
| 14          | 2 replies with test case 06                                                                                                                                                                                                                                                                      | ok              | fail             | ok                   |
| 15          | 2 replies with test case 07                                                                                                                                                                                                                                                                      | ok              | fail             | ok                   |
| 16          | 2 replies with test case 08                                                                                                                                                                                                                                                                      | fail            | fail             | fail                 |
| 17          | Multiple forwarded emails using cases 01-08:<br><br>E.g. <br>- User A sends "case 01" to User B<br>- User B forwards "case 02" to User A<br>- User A forwards "case 03" to User B<br>...<br>- User B forwards "case 08" to User A<br>- User A completes circle by forwarding "case 01" to User B | -               | -                | -                    |

## Failing cases

### 09, 10

**Plain**

`received.eml` is missing QR code images because of the bug with Exchange server and messes QR code urls:

### 11, 12

**HTML, Plain, pseudoplain**

`<img>` with the same picture gets different `cid` values. Relevant base64 strings are also different.

Diff sample

```html
- <img src="cid:image010.png@01D6D954.924C1BF0" /> +
<img src="cid:image003.png@01D6D954.B09B3410" />
```

### 13

**HTML**

Outlook amending HTML structure of the formatted text

Diff sample

```
  <LI>
  <TEXT>Evenmorenesteditem.</TEXT>
  </LI>
+ </UL>
+ </UL>
+ <UL>
+ <UL>
+ <UL>
  <LI>
  <TEXT>Evenmorenesteditem.</TEXT>
  </LI>
+ </UL>
+ </UL>
+ </UL>
+ <UL>
+ <UL>
```

**Plain**

`received.eml` is missing QR code images because of the bug with Exchange server and messes QR code urls:

### 14, 15

**Plain**

`received.eml` is missing QR code images because of the bug with Exchange server and messes QR code urls:

### 16

**HTML and Plain**

A combination of all factors above
