const fs = require("fs");

export const listDirectories = (testCasesPath: string): Array<string> => {
  return fs.readdirSync(testCasesPath).filter(function (file) {
    return fs.statSync(testCasesPath + "/" + file).isDirectory();
  });
};

const filesCache: { [key: string]: string } = {};
export const readFile = (path: string): string => {
  if (!filesCache[path]) {
    filesCache[path] = fs.readFileSync(path).toString();
  }

  return filesCache[path];
};
