import { describe } from "@jest/globals";
import { createPseudoplainTestsRunner } from "./helpers";
import { EMAIL_VENDORS } from "../src";

const path = require("path");

const TESTS_GLOBAL_PATH = "/files/outlook-outlook";
const testsPath = path.resolve(__dirname, `.${TESTS_GLOBAL_PATH}`);

describe("[Pseudo PLAIN] Outlook-Outlook normalization", () => {
  const runTests = createPseudoplainTestsRunner(
    testsPath,
    EMAIL_VENDORS.OUTLOOK
  );

  describe("Chrome-Chrome", runTests("chrome-chrome"));
  describe(
    "MacOS-MacOS",
    runTests("macos-macos", { ignore: ["03", "04", "05", "08", "09"] })
  );
  describe(
    "Windows-Windows",
    runTests("windows-windows", { ignore: ["11", "12", "16"] })
  );
});
