"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeGmailDocument = void 0;
const common_1 = require("./common");
const constants_1 = require("../../constants");
const qrCodeContainerIds = { vereignWrapperLink: 1 };
const removeQrCodeNodes = (document) => {
    const remove = (node) => {
        let toRemove = [];
        let child = node.firstChild;
        while (child) {
            if (child.nodeType == constants_1.ELEMENT_NODE) {
                toRemove = [...toRemove, ...remove(child)];
                const childElement = child;
                const id = childElement.getAttribute("id");
                if (id &&
                    Object.keys(qrCodeContainerIds).find((possibleId) => id.includes(possibleId))) {
                    toRemove.push(childElement);
                }
            }
            child = child.nextSibling;
        }
        return toRemove;
    };
    const elementsToRemove = remove(document.body);
    elementsToRemove.forEach((element) => element.parentNode.removeChild(element));
};
const normalizeGmailDocument = (document) => {
    removeQrCodeNodes(document);
    /**
     * Look for attachments panes and extract <a> tags from them
     */
    const attachmentsPanes = Array.from(document.getElementsByClassName("gmail_chip"));
    attachmentsPanes.forEach((pane) => {
        const as = pane.getElementsByTagName("a");
        Array.from(as).forEach((a) => {
            common_1.cloneAnchorFromPane(a, pane);
        });
    });
    attachmentsPanes.forEach((pane) => {
        pane.parentNode.removeChild(pane);
    });
};
exports.normalizeGmailDocument = normalizeGmailDocument;
